data Game a = Leaf a | Node [Game a];

flipeval (Leaf x) = x;
flipeval (Node ts) = listmax (map (negate.flipeval) ts);

map f [] = [];
map f (x:xs) = f x:map f xs;

negate :: Int -> Int;

neginf :: Int;
posinf :: Int;

max a b = if a>b then a else b;
min a b = if a<b then a else b;

listmax [] = neginf;
listmax (x:xs) = max x (listmax xs);

TRANSFORM fastflipeval
REDEFINE flipeval t = fastflipeval t neginf posinf
SPECIFYING fastflipeval t a b 
               = bound (flipeval (foldgame Leaf Node (:) [] t)) a b
USING 

DEFINITION flipeval,listmax,map,(.);

boundmax: bound (max c d) a b 
        = let a'=bound c a b in 
           if a'==b then b 
           else bound d a' b;
{-
boundmax: bound (max c d) a b = if d>=b then b else bound d (bound c a b) b;
-}
negbound: bound (negate c) a b 
        = negate (bound c (negate b) (negate a));

boundneginf: bound neginf a b = a;

fusion:
   f (foldgame leaf node cons nil t) 
    = foldgame leaf' node' cons' nil' t,
  if {
        \x -> f (leaf x) = \x -> leaf' x;
        f' nil = nil';
        \x y -> f' (cons x y) = \x y -> cons' (f x) (f' y);
        \x -> f (node x) = \x -> node' (f' x)
     }


END;

foldgame leaf node cons nil (Leaf x) = leaf x;
foldgame leaf node cons nil (Node ts) =
   node (foldr (cons.foldgame leaf node cons nil) nil ts);

foldr f e [] = e;
foldr f e (x:xs) = f x (foldr f e xs);

bound x a b = min (max a x) b;
